<nb-card>
    <nb-card-header>
        Create recipe
        <span style="float: right">
            <button nbButton>
                <nb-icon icon="close" (click)="close()"></nb-icon>
            </button>
        </span>
    </nb-card-header>
    <nb-card-body>
        <nb-layout-column>
            <div class="container-md">
                <form [formGroup]="recipForm" [nbSpinner]="loader">
                    <div class="row">
                        <div class="col-3">
                            Name of the recipe
                        </div>
                        <div class="col-9" formGroupName="item">
                            <nb-form-field>
                                <input nbInput placeholder="Start to type some letter" formControlName="name"
                                       type="text" (keyup)="checkName()"
                                       [nbAutocomplete]="auto"/>

                                <nb-autocomplete #auto (selectedChange)="setItem($event)">
                                    <nb-option *ngFor="let item of items$ | async" [value]="item._id">
                                        {{ item.name }}
                                    </nb-option>
                                </nb-autocomplete>
                            </nb-form-field>
                        </div>
                        <div class="col-3">
                            Profession
                        </div>
                        <div class="col-9">
                            <nb-select formControlName="profession">
                                <nb-option *ngFor="let profession of professions"
                                           [value]="profession">{{profession}}</nb-option>
                            </nb-select>
                        </div>
                        <div class="col-3">
                            NPC Price
                        </div>
                        <div class="col-9">
                            <app-price [price]="recipForm.value.item.fixedPrice"
                                       (valueChange)="recipForm.patchValue({item : {fixedPrice: $event}})"></app-price>
                        </div>
                    </div>
                    <div class="row" formGroupName="itemResult">
                        <div class="col-3">
                            Item created
                        </div>
                        <div class="col-9">
                            <nb-form-field>
                                <input nbInput placeholder="Start to type some letter" formControlName="name"
                                       type="text" (keyup)="checkName(-1)"
                                       [nbAutocomplete]="auto2"/>

                                <nb-autocomplete #auto2 (selectedChange)="setItem($event, -1)">
                                    <nb-option *ngFor="let item of itemsResult$ | async" [value]="item._id">
                                        {{ item.name }}
                                    </nb-option>
                                </nb-autocomplete>
                            </nb-form-field>
                        </div>
                        <div class="col-3">
                            Quantity created
                        </div>
                        <div class="col-7">
                            <input nbInput type="number" formControlName="quantity" placeholder="Quantity"/>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <p>Components :
                                <button nbButton (click)="addComponent()">
                                    <nb-icon icon="plus-circle" status="primary"></nb-icon>
                                </button>
                            </p>
                        </div>
                    </div>
                    <div formArrayName="components">
                        <div class="row" *ngFor="let component of components.controls; let i = index"
                             [formGroupName]="i">
                            <div class="col-3">
                                <button nbButton (click)="removeComponent(i)">
                                    <nb-icon icon="minus-circle" status="danger"></nb-icon>
                                </button>
                                {{i + 1}}
                            </div>
                            <div class="col-7">
                                <nb-form-field>
                                    <input nbInput placeholder="Name" formControlName="name" type="text"
                                           (keyup)="searchOn($event, i); checkName(i)"
                                           [nbAutocomplete]="auto"/>

                                    <nb-autocomplete #auto (selectedChange)="setItem($event, i)" (select)="setItem($event.toString(), i)">
                                        <nb-option *ngFor="let item of items$$[i] | async" [value]="item._id">
                                            {{ item.name }}
                                        </nb-option>
                                    </nb-autocomplete>
                                </nb-form-field>
                            </div>
                            <div class="col-3">
                                Quantity
                            </div>
                            <div class="col-7">
                                <input nbInput type="number" formControlName="quantity" placeholder="Quantity"/>
                            </div>
                            <div class="col-3">
                                NPC Price
                            </div>
                            <div class="col-7">
                                <app-price [price]="components.value[i].fixedPrice"
                                           (valueChange)="componentPriceChange(i, $event)"></app-price>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <button nbButton [disabled]="!recipForm.valid || !recipForm.dirty" status="success"
                                (click)="saveRecipe()">Save
                        </button>
                    </div>
                </form>
            </div>
        </nb-layout-column>
    </nb-card-body>
</nb-card>
